com.google.web.bindery.event.shared.testing

## Class RecordingEventBus

- java.lang.Object
- - com.google.web.bindery.event.shared.EventBus
  - - com.google.web.bindery.event.shared.testing.RecordingEventBus

    public class RecordingEventBus
    extends EventBus

Wraps an `EventBus` implementation to keep track of fired events.

### Constructor Summary

Constructors
Constructor and Description
`RecordingEventBus()`
`RecordingEventBus(EventBus wrapped)`

### Method Summary

All Methods Instance Methods Concrete Methods
`<H> HandlerRegistration` `addHandler(Event.Type<H> type, H handler)` Adds an unfiltered handler to receive events of this type from all sources.
`<H> HandlerRegistration` `addHandlerToSource(Event.Type<H> type, java.lang.Object source, H handler)` Adds a handler to receive events of this type from the given source.
`void` `clearFiredEvents()` Clears the remembered list of fired events.
`void` `fireEvent(Event<?> event)` Fires the event from no source.
`void` `fireEventFromSource(Event<?> event, java.lang.Object source)` Fires the given event to the handlers listening to the event's type.
`boolean` `wasEventFired(Event<?> event)` Returns `true` if the specified event was fired.

### Methods inherited from class com.google.web.bindery.event.shared.EventBus

`dispatchEvent, setSourceOfEvent`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RecordingEventBus

    public RecordingEventBus()

#### RecordingEventBus

    public RecordingEventBus(EventBus wrapped)

### Method Detail

#### addHandler

    public <H> HandlerRegistration addHandler(Event.Type<H> type,
                                              H handler)

Description copied from class: `EventBus`
Adds an unfiltered handler to receive events of this type from all sources.

It is rare to call this method directly. More typically an `Event` subclass will provide a static `register` method, or a widget will accept handlers directly.

Specified by:
  `addHandler` in class `EventBus`
Type Parameters:
  `H` - The type of handler
Parameters:
  `type` - the event type associated with this handler
  `handler` - the handler
Returns:
  the handler registration, can be stored in order to remove the handler later

#### addHandlerToSource

    public <H> HandlerRegistration addHandlerToSource(Event.Type<H> type,
                                                      java.lang.Object source,
                                                      H handler)

Description copied from class: `EventBus`
Adds a handler to receive events of this type from the given source.

It is rare to call this method directly. More typically a `Event` subclass will provide a static `register` method, or a widget will accept handlers directly.

Specified by:
  `addHandlerToSource` in class `EventBus`
Type Parameters:
  `H` - The type of handler
Parameters:
  `type` - the event type associated with this handler
  `source` - the source associated with this handler
  `handler` - the handler
Returns:
  the handler registration, can be stored in order to remove the handler later

#### clearFiredEvents

    public void clearFiredEvents()

Clears the remembered list of fired events.

#### fireEvent

    public void fireEvent(Event<?> event)

Description copied from class: `EventBus`
Fires the event from no source. Only unfiltered handlers will receive it.

Any exceptions thrown by handlers will be bundled into a `UmbrellaException` and then re-thrown after all handlers have completed. An exception thrown by a handler will not prevent other handlers from executing.

Specified by:
  `fireEvent` in class `EventBus`
Parameters:
  `event` - the event to fire

#### fireEventFromSource

    public void fireEventFromSource(Event<?> event,
                                    java.lang.Object source)

Description copied from class: `EventBus`
Fires the given event to the handlers listening to the event's type.

Any exceptions thrown by handlers will be bundled into a `UmbrellaException` and then re-thrown after all handlers have completed. An exception thrown by a handler will not prevent other handlers from executing.

Specified by:
  `fireEventFromSource` in class `EventBus`
Parameters:
  `event` - the event to fire

#### wasEventFired

    public boolean wasEventFired(Event<?> event)

Returns `true` if the specified event was fired.